#!/bin/bash

# ----------------------------------------------------------------------------------------------------
# lanch_name : download_toolchain
# lanch_id   : 
# lanch_help : download toolchain(gcc)
# lanch_argv : [-help] 帮助
# lanch_argv : [-list] 获取下载列表
# ----------------------------------------------------------------------------------------------------

echo "[Git Branch Auto Download]"

# ----------------------------------------------------------------------------------------------------
# git@codechina.csdn.net:codefast/toolchain.git
# https://codechina.csdn.net/codefast/toolchain.git
git_address=codechina.csdn.net
git_group=codefast
git_project=toolchain
# --------- --------- --------- --------- --------- --------- --------- --------- --------- ---------
git_access_use_https=1
git_branch_common=script


# ----------------------------------------------------------------------------------------------------
# Automatic generation
git_repository_git="git@${git_address}:${git_group}/${git_project}.git"
git_repository_https="https://${git_address}/${git_group}/${git_project}.git"
if [ ${git_access_use_https} ]; then
	git_repository_address=${git_repository_git}
else
	git_repository_address=${git_repository_https}
fi	



# ----------------------------------------------------------------------------------------------------
function SHELL_FUNCTION_HELP(){
	echo "HELP"
	echo "  OPTIONS: [-help] [-h] 帮助"
	echo "  OPTIONS: [-list] [-l] 显示可以下载的toolchain列表"
	echo "  OPTIONS: [\${KEYWORD}] 下载包含KEYWORD名称的toolchain, 支持多个KEYWORD"
	echo "  USAGE: ./download_toolchain.sh gcc"
	echo "  USAGE: ./download_toolchain.sh gcc 8.3"
	echo "  USAGE: ./download_toolchain.sh gcc 8.3 mini"
	exit
}
function SHELL_FUNCTION_PASER(){
	if [ -z "$1" ]; then
		SHELL_FUNCTION_HELP
	fi
	unset SHELL_OPTIONS_LIST
	for argv in $*; do
		if [ "$argv" == "-h" ] || [ "$argv" == "-help" ]; then
			SHELL_FUNCTION_HELP
		fi
		if [ "$argv" == "-l" ] || [ "$argv" == "-list" ]; then
			SHELL_OPTIONS_LIST=1
		fi
	done
}
function SHELL_FUNCTION_KERNAL(){
	echo "git_repository (git)   : ${git_repository_git}"
	echo "git_repository (https) : ${git_repository_https}"

	git init 1>log.txt 2>&1
	
	git remote add origin ${git_repository_address} 1>log.txt 2>&1
	
	git remote show origin > git_remote.log.txt

	cat git_remote.log.txt | grep "gcc" | sed -e 's/^[ ]*//g' | cut -d ' ' -f 1 > git_branch.log.txt

	if [ ${SHELL_OPTIONS_LIST} ]; then
		echo "[git branch list]"
		cat -n git_branch.log.txt
		return
	fi	
	
	for argv in $*; do
		cat git_branch.log.txt | grep "${argv} " > git_branch.log.txt.next
		if [[ ! -s git_branch.log.txt.next ]] ;	then
			cat git_branch.log.txt | grep "${argv}" > git_branch.log.txt.next			
		fi
		
		mv git_branch.log.txt.next git_branch.log.txt
	done


	git_branch=$(cat git_branch.log.txt | head -n 1)
	git_branch=`echo ${git_branch}`
	git_branch=${git_branch%% *}
	
	echo "git_branch     : ${git_branch}"
	echo "wget_cmd       : wget https://${git_address}/${git_group}/${git_project}/-/archive/${git_branch}/${git_project}-${git_branch}.tar.gz"

	rm ${git_project}-${git_branch}.tar.gz 1>log.txt 2>&1
	wget https://${git_address}/${git_group}/${git_project}/-/archive/${git_branch}/${git_project}-${git_branch}.tar.gz -q --show-progress
	tar zxf ${git_project}-${git_branch}.tar.gz

	wget https://${git_address}/${git_group}/${git_project}/-/archive/${git_branch_common}/${git_project}-${git_branch_common}.tar.gz -q --show-progress
	tar zxf ${git_project}-${git_branch_common}.tar.gz
	rm toolchain-${git_branch_common}/README.md

	rm -rf ../${git_branch}
	mkdir -p ../${git_branch}
	mv toolchain-${git_branch}/* ../${git_branch}/
	mv toolchain-${git_branch_common}/* ../${git_branch}/

	return
}

SHELL_FUNCTION_PASER $*
TEMP_DIR=TEMP_$(date "+%Y.%m.%d.%H.%M.%S")
mkdir -p ${TEMP_DIR}
cd ${TEMP_DIR}
	SHELL_FUNCTION_KERNAL $*
	cd ..
rm -rf ./${TEMP_DIR}